#!/bin/bash

#------------------------------

#查詢國家
get_ip_country() {

    #取得國家名稱

    if [[ ${1} =~ ':' ]]; then

        ipcountry=$(/usr/bin/geoiplookup6 ${1} | grep 'Country' | cut -d ':' -f 2 | cut -d ',' -f 2 | sed s/[[:space:]]//g)
    else
        ipcountry=$(/usr/bin/geoiplookup ${1} | grep 'Country' | cut -d ':' -f 2 | cut -d ',' -f 2 | sed s/[[:space:]]//g)

    fi

}

#查詢是否為允許的IP
get_ip_allow() {

    allowip=$(host ${1})
    allowip_re=""
    if [[ ${allowip} =~ "google" ]] || [[ ${allowip} =~ "cloudfront" ]] || [[ ${allowip} =~ "uptimerobot" ]]; then

        allowip_re=ALLOW

    fi

}

#查詢是否已阻擋
ip_deny() {

    output1=$(
        iptables -L -n | grep -q "${1}"
        echo $?
    )

    if [[ ${output1} == '0' ]]; then

        csf_ip=$(iptables -L -n | grep ${1} | head -1 | awk '{print $1}')
    else

        csf_ip='--'

    fi
}

if [[ -z "$1" ]] || [[ $1 != "-h" ]] && [[ $1 != "-m" ]]; then

    echo "
請帶入參數
-h   一小時
-m   10分鐘  
"
    exit
fi

while [ -z "${se_mod}" ]; do
    echo "
1. all IP 
2. Wordpress
"

    read -p "請輸入1 or 2 :" se_mod

    case "${se_mod}" in
    1)
        mod=""
        ;;
    2)
        mod="wp-login.php|xmlrpc|wp-cron.php"
        ;;
    *) # other
        se_mod=""
        echo -n "輸入1 or 2:"
        ;;
    esac
done

case ${1} in

-m)
    while :; do
        a=1
        index=0
        index1=0
        csf_ip=""
	csf_deny=""
        echo " " >/root/drop_wp.log
        echo " " >/root/dropipcsf.log
        for i in {1..10}; do
            time[$index]=$(date --date="-${i}min" +"%d/%b/%Y:%H:%M")
            index=$(expr $index + 1)
        done
        grep -s -E " ${time[0]} | ${time[1]}| ${time[2]}| ${time[3]} | ${time[4]} | ${time[5]} | ${time[6]} |${time[7]} | ${time[8]} |${time[9]}" /var/log/apache2/domlogs/* | grep -E "${mod}" | awk {'print $1'} | awk -F ':' {'print $2'} | sort | uniq -c | sort -n | tail -n 10 >/root/drop_wp.log
        echo ""

        printf "%-8s  %-8s %13s  %20s \t  %16s \n" "編號" "連線數" "IP" "國家" "防火牆"
        echo "-----------------------------------------------------------------------"

        while read line; do

            y=$(echo ${line} | awk {'print $1'})
            x=$(echo ${line} | awk {'print $2'})
            get_ip_allow ${x}

            if [[ ${allowip_re} == 'ALLOW' ]]; then

                continue

            fi

            ip_deny ${x}
            get_ip_country ${x}

            echo "no.${a} ${x}" >>/root/dropipcsf.log
            printf "%-8s %-10s %-13s \t %-25s %-3s \n" ${a} ${y} ${x} ${ipcountry} ${csf_ip}
            a=$(expr $a + 1)

        done </root/drop_wp.log
        echo "-----------------------------------------------------------------------"
        echo ""

        while [ -z "$csf_deny" ]; do
            read -p "輸入編號封鎖ip 或 r 重整: " csf_deny

            case "${csf_deny}" in
            [0-9])
                yy=$(cat /root/dropipcsf.log | grep -w "no.${csf_deny}" | cut -d ' ' -f 2 | sed s/[[:space:]]//g)
                csf -d ${yy}
                ;;
            [0-9][0-9])
                yy=$(cat /root/dropipcsf.log | grep -w "no.${csf_deny}" | cut -d ' ' -f 2 | sed s/[[:space:]]//g)
                csf -d ${yy}
                ;;
            [r])
                csf_deny=""
		break
		;;
            *) # other
                csf_deny=""
                ;;
            esac
        done

    done

    ;;

-h)

    while :; do
        a=1
        index=0
        index1=0
        csf_ip=""
        echo " " >/root/drop_wp.log
        echo " " >/root/dropipcsf.log

        for i in {1..10}; do
            time[$index]=$(date --date="-${i}min" +"%d/%b/%Y:%H:%M")
            index=$(expr $index + 1)
        done

        grep -s $(date +"%d/%b/%Y:%H") /var/log/apache2/domlogs/* | grep -E "${mod}" | awk {'print $1'} | awk -F ':' {'print $2'} | sort | uniq -c | sort -n | tail -n 10 >/root/drop_wp.log
        echo ""

        printf "%-8s  %-8s %13s  %20s \t  %16s \n" "編號" "連線數" "IP" "國家" "防火牆"
        echo "-----------------------------------------------------------------------"

        while read line; do

            y=$(echo ${line} | awk {'print $1'})
            x=$(echo ${line} | awk {'print $2'})
            get_ip_allow ${x}

            if [[ ${allowip_re} == 'ALLOW' ]]; then

                continue

            fi

            ip_deny ${x}
            get_ip_country ${x}

            echo "no.${a} ${x}" >>/root/dropipcsf.log
            printf "%-8s %-10s %-13s \t %-25s %-3s \n" ${a} ${y} ${x} ${ipcountry} ${csf_ip}
            a=$(expr $a + 1)

        done </root/drop_wp.log
        echo "-----------------------------------------------------------------------"
        echo ""

        csf_deny=""
        while [ -z "$csf_deny" ]; do
            read -p "輸入編號封鎖ip 或 r 重整: " csf_deny

            case "${csf_deny}" in
            [0-9])
                yy=$(cat /root/dropipcsf.log | grep -w "no.${csf_deny}" | cut -d ' ' -f 2 | sed s/[[:space:]]//g)
                csf -d ${yy}
                ;;
            [0-9][0-9])
                yy=$(cat /root/dropipcsf.log | grep -w "no.${csf_deny}" | cut -d ' ' -f 2 | sed s/[[:space:]]//g)
                csf -d ${yy}
                ;;
            [r])
                csf_deny=""
                break
		;;
            *) # other
                csf_deny=""
                ;;
            esac
        done
    done
    ;;

*)
    echo "請帶入參數
-h   一小時
-m   10分鐘  
        "
    ;;
esac

